<template>
  <div>
    <v-menu bottom left offset-y>
      <template #activator="{ on: menu }">
        <v-tooltip left>
          <template #activator="{ on: tooltip }">
            <v-btn
              outlined
              color="primary"
              style="width: 100%"
              class="mb-4"
              v-on="{ ...tooltip, ...menu }"
            >
              <span v-if="mobile && $vuetify.breakpoint.mdAndDown">{{
                currentUsedLangISO639
              }}</span>
              <span v-else>{{
                currentUsedLangISO639 +
                " - " +
                iso639Names[currentUsedLangISO639]
              }}</span>
            </v-btn>
          </template>
          <span>{{ $t("tool.langPicker.title") }}</span>
        </v-tooltip>
      </template>

      <v-list>
        <v-list-item
          v-for="(lang, index) in langCodes"
          :key="index"
          @click="setLang(lang._text)"
        >
          <v-list-item-title>{{ iso639Names[lang._text] }}</v-list-item-title>
        </v-list-item>
        <!--
        <v-list-item class="cursor-pointer" @click="addBtnClick">
          <v-list-item-title>
            {{ $t("tool.langPicker.addLanguage") }}
          </v-list-item-title>
        </v-list-item>
        -->
      </v-list>
    </v-menu>
    <v-dialog v-model="dialog" max-width="500">
      <v-card>
        <v-card-title>{{ $t("tool.langPicker.dialogTitle") }}</v-card-title>
        <v-card-text>
          <v-form v-model="valid">
            <GAutocomplete
              v-model="selectedLang"
              i18n="tool.langPicker.language"
              :items="iso639"
              :item-text="(item) => `${item.code} - ${item.name}`"
              item-value="code"
              validate="required"
            />
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn text color="error" @click="dialog = false">
            {{ $t("form.cancel") }}
          </v-btn>
          <v-spacer />
          <v-btn
            text
            color="success"
            :disabled="!valid"
            @click="confirmBtnClick"
          >
            {{ $t("form.add") }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { mapMutations, mapState } from "vuex";
import { DCCXMLElement } from "@d-ptb/dcc-js";
import GAutocomplete from "./Form/gAutocomplete";
import ISO639 from "~/assets/lists/iso-639-codes";

export default {
  name: "LanguagePicker",
  components: { GAutocomplete },
  props: {
    mobile: {
      type: Boolean,
      default: false,
    },
    card: {
      type: Boolean,
      default: false,
    },
    noPadding: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      currentTab: 0,
      selectedLang: "",
      dialog: false,
      valid: true,
    };
  },
  computed: {
    langCodes() {
      return this.$global.dccDocument.digitalCalibrationCertificate
        .administrativeData.coreData.usedLangCodeISO639_1;
    },
    iso639Names() {
      const langNames = {};
      ISO639.map((x) => (langNames[x.code] = x.name));
      return langNames;
    },
    iso639() {
      return ISO639;
    },
    ...mapState(["currentUsedLangISO639"]),
  },
  watch: {
    currentUsedLangISO639(currentUsedLangISO639) {
      this.currentTab = this.langCodes.findIndex(
        (x) => x._text === currentUsedLangISO639
      );
    },
  },
  created() {
    this.currentTab = this.langCodes.length > 0 ? 0 : null;
  },
  methods: {
    setLang(lang) {
      this.setCurrentUsedLangISO639(lang);
    },
    addBtnClick() {
      this.dialog = true;
    },
    confirmBtnClick() {
      if (
        this.langCodes.filter((x) => x._text === this.selectedLang).length === 0
      ) {
        this.langCodes.push(new DCCXMLElement({ _text: this.selectedLang }));
      }
      this.dialog = false;
    },
    ...mapMutations(["setCurrentUsedLangISO639"]),
  },
};
</script>
